import windows;
import c.stdio;
import string;

extern (C) int system (char *);

int main(char[][] args) {
	/* funciones */
	void ayuda() {
		printf('Compilador para DMD' \n 'uso: %.*s archivo... [bandera...]' \n , args[0]);
	}

	HANDLE abrir (char* arch) {
		return CreateFileA(arch,(DWORD)GENERIC_READ,(DWORD)0,(LPSECURITY_ATTRIBUTES)NULL,
			(DWORD)OPEN_EXISTING,(DWORD)FILE_ATTRIBUTE_NORMAL,NULL);
	}

	FILETIME fuente,obj;

	void recuperarTiempos(uint i) {
		char * cf,co;
		cf=toStringz(args[i]~'.d');
		co=toStringz(args[i]~'.obj');

		HANDLE f,o;
		f=abrir(cf);
		GetFileTime(f, null, null, &fuente);
		CloseHandle(f);
		o=abrir(co);
		GetFileTime(o, null, null, &obj);
		CloseHandle(o);
	}
	/* fin funciones */

	if (args.length<2) ayuda();
	else {
		bit [] comp = new bit [args.length];
		bit ejec=false;

		for (uint i=1;i<args.length;i++) {
			if ( find(args[i],(char)'-')==0 ) comp[i]=true;
			else {
				recuperarTiempos(i);		
				int cft=CompareFileTime(&fuente,&obj);
				comp[i]=(cft!=-1);
				if (comp[i]) ejec=true;
			}
		}

		if (ejec) {
			args.sort;
			args.reverse;
			printf('compilando...' \n);
			char[] cmd = 'dmd ';
			for (uint i=1;i<args.length;i++)
				if (comp[i]) cmd ~=(args[i]~' ');
			printf('%.*s'\n,cmd);
			system (cmd);
			return -1;
		}
	}
	return 0;
}